import javax.servlet.http.HttpServletRequest
import javax.servlet.http.HttpServletResponse

import org.apache.commons.lang3.StringEscapeUtils
import org.bonitasoft.console.common.server.page.PageContext
import org.bonitasoft.console.common.server.page.PageController
import org.bonitasoft.console.common.server.page.PageResourceProvider

import com.bonitasoft.engine.api.TenantAPIAccessor;
import org.bonitasoft.engine.session.APISession;
import org.bonitasoft.engine.api.CommandAPI;
import org.bonitasoft.engine.command.CommandDescriptor;
import org.bonitasoft.engine.command.CommandCriterion;
import org.codehaus.groovy.tools.shell.CommandAlias;

import java.util.logging.Logger;
import org.json.simple.JSONObject;
	
public class Index implements PageController {

		@Override
		public void doGet(HttpServletRequest request, HttpServletResponse response, PageResourceProvider pageResourceProvider, PageContext pageContext) {
	
		Logger logger= Logger.getLogger("org.bonitasoft");
		
		
				try {
						def String indexContent;
						pageResourceProvider.getResourceAsStream("Index.groovy").withStream { InputStream s-> indexContent = s.getText() };
						response.setCharacterEncoding("UTF-8");
			
			String action=request.getParameter("action");
			logger.severe("###################################### YES action is["+action+"] page=["+request.getParameter("page")+"] !");
			if (action==null || action.length()==0 )
			{
				logger.severe("###################################### RUN Default !");
				
				runTheBonitaIndexDoGet( request, response,pageResourceProvider,pageContext);
				return;
			}
			
			APISession session = pageContext.getApiSession()
			CommandAPI commandApi = TenantAPIAccessor.getCommandAPI(session);
	
			
			
			if ("listcmd".equals(action))
			{
				int startIndex = getIntegerParameter(request,"startIndex",0);
				int maxResult = getIntegerParameter(request,"maxResult",100);
				List<CommandDescriptor> listCmd = commandAPI.getAllCommands(startIndex, maxResults,  CommandCriterion.NAME_ASC);
				ArrayList<HashMap<String,Object>> listCmdJson = new ArrayList<HashMap<String,Object>>();
				for (CommandDescriptor commandDescriptor : listCmd)
				{
						HashMap<String,Object> mapCmd = new HashMap<String,Object>();
						mapCmd.put("id", commandDescriptor.getId());
						mapCmd.put("description", commandDescriptor.getDescription());
						mapCmd.put("Implementation", commandDescriptor.getImplementation());
						mapCmd.put("name", commandDescriptor.getName());
						mapCmd.put("issystemcommand", commandDescriptor.isSystemCommand());
						listCmdJson.add( mapCmd );
				}
				String jsonSt = JSONArray.toJSONString( listCmdJson);
				out.write( jsonSt );
				out.flush();
				out.close();
				return;
				
			}
			// APISession apiSession = pageContext.getApiSession();
			// CommandAPI commandAPI = TenantAPIAccessor.getCommandAPI(session);
			
			
			// display the result
						def PrintWriter out = response.getWriter()

						/*
						 *
						 * bonita.css can be retrieved using pageResourceProvider.getBonitaThemeCSSURL()
						 * other css/js resources can be retrieved using pageResourceProvider.getResourceURL("<path in the custom page zip>")
						 *
						 */

						out.write("""
            <html lang="en">
            <head>
            <meta charset="utf-8">
            <link href="${pageResourceProvider.getBonitaThemeCSSURL()}" type="text/css" rel="stylesheet" />
            <link href="${pageResourceProvider.getResourceURL("css/jquery-ui-1.10.4.custom.css")}" rel="stylesheet">
            <link href="${pageResourceProvider.getResourceURL("css/style.css")}" rel="stylesheet">
            <script src="${pageResourceProvider.getResourceURL("js/jquery-1.10.2.js")}"></script>
            <script src="${pageResourceProvider.getResourceURL("js/jquery-ui-1.10.4.custom.js")}"></script>
            <link href="${pageResourceProvider.getResourceURL("css/prettify.css")}" type="text/css" rel="stylesheet" />
            <script type="text/javascript" src="${pageResourceProvider.getResourceURL("js/prettify.js")}"></script>
            """)
						out.write('''
                        
            <style type="text/css">
            pre {
                background-color: #f8f8f8;
                font-family: monospace;
            }
            .toolbar {
                margin-top: 30px;
                margin-left: 40px;
                margin-bottom: 30px
            }
            </style>
            </head>            
            <body>Hello ">
            <div id="wrap">
            <div id="main">
            
             <h1>Command list</h1>
             <div>
					
            ''')
						
						out.write("<p>Command list</p>");
			/*
			String startIndexListCommandAPIst=request.getParameter("startindexlistcommandapi");
			int startIndexListCommandAPI = 0;
			try
			{
				startIndexListCommandAPI = Integer.valueOf(startIndexListCommandAPIst);
			}
			catch(Exception e)
			{};
			
			List<CommandDescriptor> listCommand = commandAPI.getAllCommands( startIndexListCommandAPI, 100, CommandCriterion.NAME_ASC ) ;
					 out.write("<table>");
			for (CommandDescriptor command : listCommand)
			{
				out.write("<tr><td>"+command.getName()+"</td><td>"+command.getId()+"</td><td>"+command.getDescription()+"</td></tr>");
			}
					 out.write("</table>");
			out.write("<input id=\""+startindexlistcommandapi+"\">"+startIndexListCommandAPI+"</input>");
							*/
				
				
						out.write("</div>");
						out.write("<h4>Execute a command</h4>");
						out.write("<div>");
						out.write("</div>");

						out.write("<h3>Upload a command</h3>");
						out.write("<div>");
						out.write("</div>");
						
						out.write("<div id=\"footer\">Bonitasoft  2014</div>");
						out.write("</body>");
						out.write("</html>");
						
						out.flush();
						out.close();
				} catch (Exception e) {
		

			StringWriter sw = new StringWriter();
			e.printStackTrace(new PrintWriter(sw));
			String exceptionDetails = sw.toString();

			logger.severe("Exception ["+e.toString()+"] at "+exceptionDetails);

				}
		}

	private int getIntegerParameter(HttpServletRequest request, String paramName, int defaultValue)
	{
		String valueParamSt = request.getParameter(paramName);
		if (valueParamSt==null  || valueParamSt.length()==0)
			return defaultValue;
		int valueParam=defaultValue;
		try
		{
			valueParam = Integer.valueOf( valueParamSt );
		}
		catch( Exception e)
		{
			valueParam= defaultValue;
		}
		return defaultValue;
	}
		private void runTheBonitaIndexDoGet(HttpServletRequest request, HttpServletResponse response, PageResourceProvider pageResourceProvider, PageContext pageContext) {
				try {
						def String indexContent;
						pageResourceProvider.getResourceAsStream("index.html").withStream { InputStream s->
								indexContent = s.getText()
						}
						
						def String pageResource="pageResource?&page="+ request.getParameter("page")+"&location=";
						
						indexContent= indexContent.replace("@_USER_LOCALE_@", request.getParameter("locale"));
						indexContent= indexContent.replace("@_PAGE_RESOURCE_@", pageResource);
						
						response.setCharacterEncoding("UTF-8");
						PrintWriter out = response.getWriter();
						out.print(indexContent);
						out.flush();
						out.close();
				} catch (Exception e) {
						e.printStackTrace();
				}
		}

}
